import { isStrategy, TAKE_EVERY } from './strategy';
export function normalizeConfig(name, config) {
    if (config === undefined) {
        config = typeof name === 'object' ? name : {};
    }
    if (typeof name === 'string') {
        config.name = name;
    }
    if (config.handler === undefined) {
        config.handler = noop;
    }
    if (config.strategy === undefined) {
        config.strategy = TAKE_EVERY;
    }
    return config;
}
export function normalizeParams(defaultStrategy, paramsOrStrategy, strategyOrNothing) {
    let params;
    let strategy;
    if (isStrategy(paramsOrStrategy)) {
        strategy = paramsOrStrategy;
        params = undefined;
    }
    else {
        strategy = strategyOrNothing || defaultStrategy;
        params = paramsOrStrategy;
    }
    return { params, strategy };
}
function noop() {
    console.error('no handler used');
    return Promise.resolve();
}
