import { CancelledError } from './error';
export const cancel = Symbol('cancel');
export function wrap(promise) {
    let cancelPromise;
    const cancelable = new Promise((_, reject) => {
        cancelPromise = function (strategy) {
            reject(new CancelledError(strategy));
            if (cancel in promise && typeof promise[cancel] === 'function') {
                promise[cancel]();
            }
        };
    });
    return Object.assign(Promise.race([promise, cancelable]), {
        [cancel]: cancelPromise,
    });
}
